/*
MPEG 2 decoder bitstream xfer
*/

#include <stdio.h>
#include <stdlib.h>

#define	TRUE		1
#define	FALSE		0

unsigned	char	buffer422[1920 * 1088 * 2];

int main(int argc, char **argv)
{
	FILE	*fpout;
	int	x, y, index = 0;
	unsigned int	horz = 1920;
	unsigned int	vert = 1080;

	if (argc != 2) {
		fprintf(stderr, "usage: needle<outfile>\n");
		exit(-1);
	}

	/*--- open binary file (for parsing) ---*/
	fpout = fopen(argv[1], "wb");
	if (fpout == 0) {
		fprintf(stderr, "Cannot open output file <%s>\n", argv[1]);
		exit(-1);
	}

	for(y = 0; y < vert / 2; y++)  {
		for(x = 0; x < horz / 2; x++)  {
			if(x == 80 || x == 160 || x == 161)  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
#if 0
			else if(x >= 288 && x < 400)  {
				buffer422[index++] = 128;
				buffer422[index++] = 7;
			}
			else if(x >= 512 && x < 624)  {
				buffer422[index++] = 128;
				buffer422[index++] = 25;
			}
			else if(x >= 736 && x < 848)  {
				buffer422[index++] = 128;
				buffer422[index++] = 34;
			}
#endif
			else  {
				buffer422[index++] = 128;
				buffer422[index++] = 16;
			}
		}
		for(x = 0; x < horz / 2; x++)  {
			if(x == 880 || x == 800 || x == 799)  {
				buffer422[index++] = 128;
				buffer422[index++] = 16;
			}
#if 0
			else if(x >= 128 && x < 240)  {
				buffer422[index++] = 128;
				buffer422[index++] = 244;
			}
			else if(x >= 352 && x < 464)  {
				buffer422[index++] = 128;
				buffer422[index++] = 226;
			}
			else if(x >= 576 && x < 688)  {
				buffer422[index++] = 128;
				buffer422[index++] = 217;
			}
#endif
			else  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
		}
	}

	for(y = 0; y < vert / 2; y++)  {
		for(x = 0; x < horz / 2; x++)  {
			if(x == 80 || x == 160 || x == 161)  {
				buffer422[index++] = 128;
				buffer422[index++] = 16;
			}
#if 0
			else if(x >= 288 && x < 400)  {
				buffer422[index++] = 128;
				buffer422[index++] = 244;
			}
			else if(x >= 512 && x < 624)  {
				buffer422[index++] = 128;
				buffer422[index++] = 226;
			}
			else if(x >= 736 && x < 848)  {
				buffer422[index++] = 128;
				buffer422[index++] = 217;
			}
#endif
			else  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
		}
		for(x = 0; x < horz / 2; x++)  {
			if(x == 880 || x == 800 || x == 799)  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
#if 0
			else if(x >= 128 && x < 240)  {
				buffer422[index++] = 128;
				buffer422[index++] = 7;
			}
			else if(x >= 352 && x < 464)  {
				buffer422[index++] = 128;
				buffer422[index++] = 25;
			}
			else if(x >= 576 && x < 688)  {
				buffer422[index++] = 128;
				buffer422[index++] = 34;
			}
#endif
			else  {
				buffer422[index++] = 128;
				buffer422[index++] = 16;
			}
		}
	}

	fwrite(&buffer422[0], 1, horz * vert * 2, fpout);
	fclose(fpout);
	return 0;
}
