/*
MPEG 2 decoder bitstream xfer
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define	TRUE		1
#define	FALSE		0

unsigned	char	buffer422[1920 * 1088 * 2];

int main(int argc, char **argv)
{
	FILE	*fpout;
	int	i, j, k, x, y, count, frames, index;
	double	xf, yf, m, b, q;
	double	angle = 0.0;
	double	angle2 = 357.0;
	char	outfilename[] = {"vertrezmotion00.yuv"};
	int	frame = 0;
	char	s[50];

	if (argc != 1) {
		fprintf(stderr, "usage: vertmot\n");
		exit(-1);
	}

	for(frames = 0; frames < 60; frames++)
	{
		index = 0;
		/*--- open binary file (for parsing) ---*/
		fpout = fopen(&outfilename[0], "wb");
		if (fpout == 0) {
			fprintf(stderr, "Cannot open output file <%s>\n", &outfilename[0]);
			exit(-1);
		}

		sprintf(s, "%02d", ++frame);
		for (i = 0; i < 2; i++) {
			outfilename[i+13] = s[i];
		}

		for(j = 0; j < 120; j++)  {
			for(i = 0; i < 1920; i++)  {
				if((j % 40) == 0 || (i % 40) == 0)  {
	                        	buffer422[index++] = 0x80;
	                        	buffer422[index++] = 180;
				}
				else  {
	                        	buffer422[index++] = 0x80;
	                        	buffer422[index++] = 126;
				}
			}
		}
		count = 0;
		y = 16;
		for(j = 0; j < 120; j++)  {
			for(i = 0; i < 1920; i++)  {
	                        buffer422[index++] = 0x80;
	            	        buffer422[index++] = y;
			}
			count++;
			if(count == 1)  {
				count = 0;
				if(y == 16)  {
					y = 235;
				}
			else  {
					y = 16;
				}
			}
		}
		for(j = 0; j < 120; j++)  {
			for(i = 0; i < 1920; i++)  {
				if((j % 40) == 0 || (i % 40) == 0)  {
	                        	buffer422[index++] = 0x80;
	                        	buffer422[index++] = 180;
				}
				else  {
	                        	buffer422[index++] = 0x80;
	                        	buffer422[index++] = 128;
				}
			}
		}
		count = 0;
		y = 16;
		for(j = 0; j < 120; j++)  {
			for(i = 0; i < 1920; i++)  {
	                        buffer422[index++] = 0x80;
	            	        buffer422[index++] = y;
			}
			count++;
			if(count == 2)  {
				count = 0;
				if(y == 16)  {
					y = 235;
				}
				else  {
					y = 16;
				}
			}
		}
		for(j = 0; j < 120; j++)  {
			for(i = 0; i < 1920; i++)  {
				if((j % 40) == 0 || (i % 40) == 0)  {
	                        	buffer422[index++] = 0x80;
	                        	buffer422[index++] = 180;
				}
				else  {
	                        	buffer422[index++] = 0x80;
	                        	buffer422[index++] = 126;
				}
			}
		}
		count = 0;
		y = 16;
		for(j = 0; j < 120; j++)  {
			for(i = 0; i < 1920; i++)  {
	                        buffer422[index++] = 0x80;
	            	        buffer422[index++] = y;
			}
			count++;
			if(count == 3)  {
				count = 0;
				if(y == 16)  {
					y = 235;
				}
				else  {
					y = 16;
				}
			}
		}
		for(j = 0; j < 120; j++)  {
			for(i = 0; i < 1920; i++)  {
				if((j % 40) == 0 || (i % 40) == 0)  {
	                        	buffer422[index++] = 0x80;
	                        	buffer422[index++] = 180;
				}
				else  {
	                        	buffer422[index++] = 0x80;
	                        	buffer422[index++] = 128;
				}
			}
		}
		count = 0;
		y = 16;
		for(j = 0; j < 120; j++)  {
			for(i = 0; i < 1920; i++)  {
	                        buffer422[index++] = 0x80;
	            	        buffer422[index++] = y;
			}
			count++;
			if(count == 4)  {
				count = 0;
				if(y == 16)  {
					y = 235;
				}
				else  {
					y = 16;
				}
			}
		}
		for(j = 0; j < 120; j++)  {
			for(i = 0; i < 1920; i++)  {
				if((j % 40) == 0 || (i % 40) == 0)  {
	                        	buffer422[index++] = 0x80;
	                        	buffer422[index++] = 180;
				}
				else  {
	                        	buffer422[index++] = 0x80;
	                        	buffer422[index++] = 126;
				}
			}
		}
		for(b = 0; b < 16; b++)
		{
			if(angle == 90.0 || angle == 180.0 || angle == -90.0 || angle == -180.0)
			{
				angle = angle + 0.5;
			}
			m = tan((angle * 3.141592653) / 180);
			q = 16.0 * sin((angle * 3.141592653) / 180);
			k = abs(q);
			if(k <= 4)
				k = 4;
			else if(k <= 8)
				k = 8;
			else if(k <=16)
				k = 16;
			else
				k = 16;
			for(xf = -900.0; xf < 900.0; xf += 0.1)  {
				x = xf;
				yf = ((m * xf) + b);
				y = yf;
				for(i = 0, j = 0 - (k / 2); i < k; i++, j += 2)
				{
					if(y % 2)
					{
						index = ((1920 * 2 * 540) + 1921 + j) + (x * 2) - (y * 1920 * 2);
						if(index >= 0 && index < (1920 * 1080 * 2))
						{
							buffer422[index] = 235;
						}
					}
				}
			}
			if(angle2 == 90.0 || angle2 == 180.0 || angle2 == -90.0 || angle2 == -180.0)
			{
				angle2 = angle2 + 0.5;
				printf("angle2 = %f\n", angle2);
			}
			m = tan((angle2 * 3.141592653) / 180);
			q = 16.0 * sin((angle2 * 3.141592653) / 180);
			k = abs(q);
			if(k <= 4)
				k = 4;
			else if(k <= 8)
				k = 8;
			else if(k <=16)
				k = 16;
			else
				k = 16;
			for(xf = -900.0; xf < 900.0; xf += 0.1)  {
				x = xf;
				yf = ((m * xf) + b);
				y = yf;
				for(i = 0, j = 0 - (k / 2); i < k; i++, j += 2)
				{
					if((y % 2) == 0)
					{
						index = ((1920 * 2 * 540) + 1921 + j) + (x * 2) - (y * 1920 * 2);
						if(index >= 0 && index < (1920 * 1080 * 2))
						{
							buffer422[index] = 235;
						}
					}
				}
			}
		}
		fwrite(&buffer422[0], 1, 1920 * 1080 * 2, fpout);
		fclose(fpout);
		angle = angle - 6.0;
		angle2 = angle2 - 6.0;
	}
	return 0;
}
