/*
MPEG 2 decoder bitstream xfer
*/

#include <stdio.h>
#include <stdlib.h>

#define	TRUE		1
#define	FALSE		0

int main(int argc, char **argv)
{
	FILE	*fpout;
	unsigned int	i, j;
	unsigned char	y, cb, cr;

	if (argc != 2) {
		fprintf(stderr, "usage: pat<outfile>\n");
		exit(-1);
	}

	/*--- open binary file (for parsing) ---*/
	fpout = fopen(argv[1], "wb");
	if (fpout == 0) {
		fprintf(stderr, "Cannot open output file <%s>\n", argv[1]);
		exit(-1);
	}

	for(j = 0; j < 720; j++)  {
		for(i = 0; i < 4; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 180;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 162;
			cr = 142;
			cb = 44;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 131;
			cr = 44;
			cb = 156;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 112;
			cr = 58;
			cb = 72;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 84;
			cr = 198;
			cb = 184;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 65;
			cr = 212;
			cb = 100;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 35;
			cr = 114;
			cb = 212;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 4; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
	}
	for(j = 0; j < 96; j++)  {
		for(i = 0; i < 4; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 35;
			cr = 114;
			cb = 212;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 84;
			cr = 198;
			cb = 184;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 131;
			cr = 44;
			cb = 156;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 180;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 4; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
	}
	for(j = 0; j < 264; j++)  {
		for(i = 0; i < 4; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < (136 * 2); i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 7;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 25;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < (136 * 2); i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 4; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
	}
	fclose(fpout);
	return 0;
}
