/*
MPEG 2 decoder bitstream xfer
*/

#include <stdio.h>
#include <stdlib.h>

#define	TRUE		1
#define	FALSE		0

int main(int argc, char **argv)
{
	FILE	*fpout;
	unsigned int	i, j;
	unsigned char	y, cb, cr, y1, y2;

	if (argc != 2) {
		fprintf(stderr, "usage: pat<outfile>\n");
		exit(-1);
	}

	/*--- open binary file (for parsing) ---*/
	fpout = fopen(argv[1], "wb");
	if (fpout == 0) {
		fprintf(stderr, "Cannot open output file <%s>\n", argv[1]);
		exit(-1);
	}

	y = 16;
	cr = 128;
	cb = 128;
	y1 = 235;
	y2 = 128;
	for(j = 0; j < 1080; j++)  {
		for(i = 0; i < 60; i++)  {
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y2, 1, 1, fpout);
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y2, 1, 1, fpout);
		}
		for(i = 0; i < 30; i++)  {
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y1, 1, 1, fpout);
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y1, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y1, 1, 1, fpout);
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y1, 1, 1, fpout);
		}
		for(i = 0; i < 120; i++)  {
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y2, 1, 1, fpout);
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y2, 1, 1, fpout);
		}
		for(i = 0; i < 20; i++)  {
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y1, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y1, 1, 1, fpout);
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y1, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y1, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y1, 1, 1, fpout);
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y1, 1, 1, fpout);
		}
		for(i = 0; i < 120; i++)  {
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y2, 1, 1, fpout);
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y2, 1, 1, fpout);
		}
		for(i = 0; i < 60; i++)  {
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y1, 1, 1, fpout);
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y1, 1, 1, fpout);
		}
		for(i = 0; i < 120; i++)  {
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y2, 1, 1, fpout);
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y2, 1, 1, fpout);
		}
		for(i = 0; i < 120; i++)  {
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y1, 1, 1, fpout);
		}
		for(i = 0; i < 60; i++)  {
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y2, 1, 1, fpout);
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y2, 1, 1, fpout);
		}
	}
	fclose(fpout);
	return 0;
}
